/***************************************************************************
 *            historywindow.h
 *
 *  Wed Feb 23 00:27:04 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _HISTORYWINDOW_H
#define _HISTORYWINDOW_H

#include "basicwindow.h"
#include "settings.h"
#include "utilities.h"
#include "userutilities.h"
#include "gettext.h"



class historyWindow: public basicWindow
{
	public:
		historyWindow();
		~historyWindow();
	
	private:	
		GtkWidget	*historyPosition,
					*backButton,
	 				*forwardButton,
	 				*historyView,
	 				*filterEntry,
	 				*filterButton,
					*saveButton;
	
		gchar		*hoveredLink;
	
		gboolean	showURIs,
					showSmileys;
	
	
		GtkWidget* 	createWindowContent();
		void		destroyWindowContent();
		gboolean	eventCallback(gint command, gint lastResult, gpointer info);
	
		GtkWidget*  createButtonbar();
	
		void		showEntries();
		void		updateProgressBar(gint rstart, gint rend, gint rsize);
	
		void		startFiltering();
		
		void		settingsChangedCallback(gchar* sname, GList *values);
	
		// callbacks
		static void cb_filterButtonClicked(historyWindow* hw);
		static void cb_advancedFilterButtonClicked(historyWindow* hw);
		static void cb_saveHistoryButtonClicked(historyWindow* hw);
		static void cb_refreshButtonClicked(historyWindow* hw);
		static void cb_closeButtonClicked(historyWindow* hw);
		static void cb_reverseButtonClicked(GtkWidget* w, historyWindow* hw);
		static void cb_forwardButtonClicked(historyWindow* hw);
		static void cb_backButtonClicked(historyWindow* hw);
		static gboolean	cb_historyViewMouseMoved(GtkWidget* v, GdkEventMotion* event, historyWindow *self);
		static gboolean cb_historyViewVisibilityChanged(GtkWidget* v, GdkEventVisibility* event, historyWindow *self);
		static gboolean cb_historyViewURLPressed(historyWindow* self, GdkEventButton* event);

		
		static void cb_maskCheckButtonClicked(GtkWidget* w, historyWindow* hw);
};

#endif /* _HISTORYWINDOW_H */
