/***************************************************************************
 *            idactionwindow.h
 *
 *  Mon Jun 27 00:29:41 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _IDACTIONWINDOW_H
#define _IDACTIONWINDOW_H


#include "basicwindow.h"
#include "gettext.h"
#include "imownerdaemon.h"
#include "utilities.h"
#include "requestdialog.h"

typedef gboolean(*IDActionCallback)(userEventType type, gint command, gchar* id, guint pluginID, gchar* comment, gboolean toggled, gpointer data);

class IDActionWindow:public basicWindow
{
	public:
		IDActionWindow(userEventType eType, IDActionCallback cb, gpointer cbdata, gchar* introText, gchar* titleText, gboolean cvisible, gchar* toggleText, gboolean toggleBtnToggled, gchar* btnText, gchar* logoImg);
		~IDActionWindow();
	
	private:
		IDActionCallback callBack;
		gpointer		 callBackData;
		gchar			 *intro,
						 *toggleButtonText,
						 *buttonText,
						 *logoImageName;
		GtkWidget		 *idEdit,
						 *idProtocolList,
						 *toggleButton,
						 *commentBox;
		gboolean		 commentVisible,
						 toggleButtonToggled;
	
		GtkWidget*	createWindowContent();
		void		destroyWindowContent();
		void		closeWindow();
	
		GtkWidget*	createButtonbar();
		GtkWidget*  createProtoList();
	
		// callbacks
		static void cb_sendButtonClicked(IDActionWindow* self);
		static void cb_cancelButtonClicked(IDActionWindow* self);
};



#endif /* _IDACTIONWINDOW_H */
