/***************************************************************************
 *            logwindow.h
 *
 *  Fri Jul 22 01:11:22 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _LOGWINDOW_H
#define _LOGWINDOW_H

#include "basicwindow.h"
#include "imownerdaemon.h"
#include "settings.h"
#include "utilities.h"
#include "gettext.h"

class logWindow: public basicWindow
{
	public:
		logWindow(IMLogDaemon* _logDaemon);
		~logWindow();
		
	private:
		IMLogDaemon		*logDaemon;	
		GtkTextTagTable	*textTags;
		GtkWidget		*textView,
						*grepFilterEntry;
		guint			typeFilter;
		gchar			*grepFilter;
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
		GtkWidget	*createFilterbar();
		GtkWidget	*createButtonbar();
	
		void		displayMessages(GList* msg);
		void		clearMessageView();
	
		static gboolean	cb_loggingCallback(userEventType type, gint command, gint lastResult, GList* log, logWindow* self);
		static void		cb_clearButtonClicked(logWindow* self);
		static void		cb_saveButtonClicked(logWindow* self);
		static void		cb_closeButtonClicked(logWindow* self);
	
		static void		cb_typeFilterChanged(GtkWidget* checkBox, logWindow* self);
		static void		cb_grepFilterButtonClicked(logWindow* self);
};

#endif /* _LOGWINDOW_H */
