/***************************************************************************
 *            randomchat.h
 *
 *  Thu Jun 22 22:01:12 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#ifndef _RANDOMCHAT_H
#define _RANDOMCHAT_H

#include "basicwindow.h"
#include "processingani.h"
#include "icons.h"
#include "userutilities.h"

class selectRandomChatGroupWindow: public basicWindow
{
	public:
		selectRandomChatGroupWindow();
		~selectRandomChatGroupWindow();
	
		gchar		*introText,
					*titleText;
		GtkWidget	*notebook;
	
	protected:
		GtkListStore	*groupsStore;
		GtkWidget		*groupsView;	
	
		GtkWidget	*createWindowContent();
		
		void 		destroyWindowContent();
		virtual GtkWidget	*createButtonbar();
		virtual	void	okayButtonClicked();
	
	
		static void cb_okayButtonClicked(selectRandomChatGroupWindow* self);
};


class startRandomChatWindow: public selectRandomChatGroupWindow
{
	public:
		startRandomChatWindow();
		~startRandomChatWindow();
	
	private:
		processingAni	*sendAni;	
		GtkWidget		*findButton,
						*aliasLabel;
		IMUserDaemon	*newUser;
	
		GtkWidget	*createButtonbar();
		void		destroyWindowContent();
	
		gboolean eventCallback(gint command, gint lastResult, gpointer info);
		void	 createUserFoundWindow(IMUserDaemon	*user);
	
		void	okayButtonClicked();
	
	
	// Callbacks
	static void cb_findButtonClicked(startRandomChatWindow* self);
	static void cb_cancelButtonClicked(startRandomChatWindow* self);
	static void cb_showUserInfoButtonClicked(startRandomChatWindow* self);
	static void cb_startChatInfoButtonClicked(startRandomChatWindow* self);
	static void cb_addPermanentlyButtonClicked(startRandomChatWindow* self);
	
	static gboolean cb_foundUserEventCallback(userEventType type, gint command, gint lastResult, gpointer info, startRandomChatWindow* self);
};

#endif /* _RANDOMCHAT_H */
