/***************************************************************************
 *            settings.h
 *
 *  Mon Jul  5 23:37:40 2004
 *  Copyright  2004  User
 *  Email
 ****************************************************************************/

#ifndef _SETTINGS_H
#define _SETTINGS_H

#include "licq_icqd.h"

// #include "licq_plugin.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>
		
	
	
// Default window position and size	
typedef struct windowDefaults
{
	short int x,
			  y,
			  width,
			  height;
	
};


typedef struct awayMessages
{
	// FIXME: add other messages here
	gchar* last;
};


typedef struct defaultIconSizes
{
	gint normal,
		 large;
};


#define ICQND_TYPE_COLOR G_TYPE_POINTER

#define GDK_COLOR_SET(col,r,g,b)\
	(col)->red = r;				\
	(col)->green = g;			\
	(col)->blue = b;

#define GDK_COLOR_SET_AV(rescol, col1, col2)			\
	(rescol)->red = ((col1)->red + (col2)->red)/2;		\
	(rescol)->green = ((col1)->green + (col2)->green)/2;\
	(rescol)->blue = ((col1)->blue + (col2)->blue)/2;

typedef void (*settingChangedFunc)(gchar* sname, GList *values, gpointer data);


struct settingsFunc
{
	settingChangedFunc func;
	gpointer data;
};


struct settingsProperty
{
	gchar  	*name;
	GValue 	*val;
	GList	*hatches;
};


struct settingsSection
{
	gchar *name;
	GList *properties;  // a list of settingsProperty
	GList *funcs;		// a list of settingsFunc
};



struct settingsIcon
{
	gchar*	stockID;
	gchar*	fileName;
};


class settings
{
	public:
		settings(gchar* filename);
		~settings();	
	
		// installs new properties in [section]
		// parameterorder: gchar* name, GType, default value if there is no entry in the config
		void installProperties(gchar* sname, ...); 
	
		// changes a property for a specific section
		void setProperties(gboolean inform, gchar* sname, ...);
	
		// gets properties
		void getProperties(gchar* sname, ...);
		
		// installs a listener for changes of a specific section
		void installListener(gchar* sname, settingChangedFunc func, gpointer data, gboolean prepend);	
	
		// removes a listener for a section
		void removeListenerByData(gpointer data);
	
		// installs a hatch. Whenever something is changed this variable gets changed too
		void installHatch(gchar* sname, gchar* propname, gpointer hatch);
	
		// removes a hatch. 
		void removeHatch(gchar* sname, gchar* propname, gpointer hatch);
	
		// saves the settings
		gboolean writeSettings();
	
	
		GtkTextTagTable	*textTags;				
	private:
	
		void	applyPropertyToHatch(GValue	*prop, gpointer hatch);
	
		void	loadTextTags();	
	
		CIniFile *licqFile;	
		GList	*sections;	// a list of settingSection
	
	
		static void cb_textTagsChangedCallback(gchar* sname, GList *values, settings* self);
};



settings* settings_getSettings();
void	  settings_setSettings(settings *s);	




/*
// everything put together
class defaultSettings
{
	public:
		windowDefaults	 	*window;
		awayMessages		*awayMsgs;
		defaultIconSizes	iconSizes;
		gboolean			popupOnEvent;
		GdkPixbufAnimation	*searchingAni;
		GdkPixbuf			*smileys[28];
		GdkColor			colRed,
							colBlue,
							colTyping,
							colTypingStop,
							colConvFont,
							colConvBg;
		GtkTextTagTable		*textTags;
		bool				reverseHistory;
		gchar				*currentOwnerAlias;
		gchar				*fileDirectory;
		bool				colConvSetFont;
		bool				colConvSetBg;
	
		guchar				containerMode;
		
	
		defaultSettings();
		~defaultSettings();
		void 	 loadSettings(char* fileName);
		gboolean writeSettings(char* fileName);
		void	 loadIcons();
		void	 loadSmileys();

		void 	 createTextTags();
};


void setDefaultSettings(defaultSettings* settings);

defaultSettings* getDefaultSettings();

*/
#endif /* _SETTINGS_H */
