/***************************************************************************
 *            infowindow.cpp
 *
 *  Thu Feb 17 03:08:24 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#include "infowindow.h"



userInfoWindow::userInfoWindow()
{
	wType = UE_USERINFO;
}


userInfoWindow::~userInfoWindow()
{
	delete manager;
}


		
GtkWidget* userInfoWindow::createWindowContent()
{	
	GtkWidget	*pagetitle,
				*mainbox,
				*evbox;
	
	gint		i;
	gchar		*titleText;
	
	gchar		*headlines[] =
	{tr_NOOP("Genera_l"), tr_NOOP("M_ore"), tr_NOOP("_Interests"), tr_NOOP("Wo_rk"), tr_NOOP("A_bout"), tr_NOOP("_Last")};
	
	// create the notebook
	notebook = gtk_notebook_new();
	g_signal_connect(notebook, "switch-page", G_CALLBACK(this->cb_switchTab), this);
	
	tabs = NULL;
	
	for (i=0; i<6; i++)
	{
		pagetitle = gtk_label_new_with_mnemonic(tr(headlines[i]));
		evbox = gtk_event_box_new();
		tabs = g_list_append(tabs, evbox);
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook), evbox , pagetitle);
		
	}
			
	
	// create main vbox	
	mainbox = gtk_vbox_new(FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(mainbox), 10);
	gtk_box_pack_start(GTK_BOX(mainbox), notebook, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mainbox), createButtonbar(), FALSE, TRUE, 0);
	
	setWindowSize(400, 450);
	titleText = g_strdup_printf(tr("Information for %s"), manager->info->alias);
	setWindowTitle(titleText);
	g_free(titleText);
	
	return mainbox;
}


GtkWidget* userInfoWindow::createButtonbar()
{
	GtkWidget	*btnbox;
	
	// set up animation
	sendAni = new processingAni();
	sendAni->setupAnimation(i_getIcons()->images.searchingAni, 22, 22);
	
	// create buttons
	updateBtn 	= gtk_button_new_from_stock(GTK_STOCK_REFRESH);
	g_signal_connect_swapped(updateBtn, "clicked", G_CALLBACK(this->cb_updateButtonClicked), this);
	saveBtn		= gtk_button_new_from_stock(GTK_STOCK_SAVE);
	g_signal_connect_swapped(G_OBJECT(saveBtn), "clicked", G_CALLBACK(this->cb_saveButtonClicked), this);
	closeBtn	= gtk_button_new_from_stock(GTK_STOCK_CLOSE);
	g_signal_connect_swapped(closeBtn, "clicked", G_CALLBACK(this->cb_closeButtonClicked), this);
	
	if (!manager->parentUser->owner)
	{
		sendBtn = u_createTextStockImageButton(tr("S_end"), GTK_STOCK_OK);
		g_signal_connect_swapped(sendBtn, "clicked", G_CALLBACK(this->cb_sendButtonClicked), this);
	}
		
	btnbox = gtk_hbox_new(FALSE, 2);
	
	gtk_box_pack_start(GTK_BOX(btnbox), sendAni->widget, FALSE, FALSE, 2);
	gtk_box_pack_start(GTK_BOX(btnbox), updateBtn, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(btnbox), saveBtn, FALSE, FALSE, 0);
	if (!manager->parentUser->owner)
		gtk_box_pack_start(GTK_BOX(btnbox), sendBtn, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(btnbox), closeBtn, FALSE, FALSE, 0);
	
	
	return btnbox;
}



#define UIT_CREATE_MAINVBOX(w)								\
	w = gtk_vbox_new(FALSE, 2);								\
	gtk_container_set_border_width(GTK_CONTAINER(w), 10);
	
	
#define UIT_CREATE_SECTION_T(caption, t, c, r)							\
	fstr = g_strdup_printf("<b>%s</b>", caption);						\
	sectionLabel = gtk_label_new(fstr);									\
	g_free(fstr);														\
	gtk_label_set_use_markup(GTK_LABEL(sectionLabel), TRUE);			\
	gtk_misc_set_alignment(GTK_MISC(sectionLabel), 0.0f, 0.0f);			\
																		\
	t = gtk_table_new(r, c, FALSE);										\
	gtk_table_set_row_spacings(GTK_TABLE(t), 2);						\
	gtk_table_set_col_spacings(GTK_TABLE(t), 2);						\
	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 1.0f);				\
	gtk_alignment_set_padding(GTK_ALIGNMENT(alignment), 0, 8, 20, 0);	\
	gtk_container_add(GTK_CONTAINER(alignment), t);						


#define UIT_CREATE_TABLE_ROW_ENTRY(table, caption, entry, entrytext, cstart, cend, row)	\
	label = gtk_label_new(caption);										\
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);				\
																		\
	entry = gtk_entry_new();											\
	gtk_entry_set_text(GTK_ENTRY(entry), entrytext);					\
	gtk_widget_set_size_request(entry, 100, -1);						\
																		\
	gtk_table_attach(GTK_TABLE(table), label, cstart, cstart+1, row, row+1, GTK_FILL, GTK_FILL, 0, 0);	\
	gtk_table_attach_defaults(GTK_TABLE(table), entry, cstart+1, cend, row, row+1);


#define UIT_CREATE_TABLE_ROW_ENTRY_S(table, caption, entry, entrytext, cstart, cend, row, sizes) \
	UIT_CREATE_TABLE_ROW_ENTRY(table, caption, entry, entrytext, cstart, cend, row);	\
	gtk_size_group_add_widget(sizes, label);
	
	
	
#define UIT_CREATE_TABLE_ROW_CUSTOM(table, caption, w, cstart, cend, row)	\
	label = gtk_label_new(caption);										\
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);				\
																		\
	gtk_table_attach(GTK_TABLE(table), label, cstart, cstart+1, row, row+1, GTK_FILL, GTK_FILL, 0, 0);	\
	gtk_table_attach_defaults(GTK_TABLE(table), w, cstart+1, cend, row, row+1);

#define UIT_CREATE_TABLE_ROW_CUSTOM_S(table, caption, w, cstart, cend, row, sizes)	\
	UIT_CREATE_TABLE_ROW_CUSTOM(table, caption, w, cstart, cend, row);	\
	gtk_size_group_add_widget(sizes, label);



GtkWidget* userInfoWindow::createGeneralTab()
{
	GtkWidget		*label,
					*sectionLabel,
					*mainVBox,
					*table,
					*alignment;
	GtkSizeGroup	*labelSizes1,
					*labelSizes2;
	gchar			*fstr;

	
	labelSizes1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	labelSizes2 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	UIT_CREATE_MAINVBOX(mainVBox);

	// Name	
	UIT_CREATE_SECTION_T("General Contact Info", table, 4, 4);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Name:"), info_name1, manager->info->firstname, 0, 2, 0, labelSizes1);
	info_name2 = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(info_name2), manager->info->lastname);
	gtk_table_attach_defaults(GTK_TABLE(table), info_name2, 2, 4, 0, 1);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Alias:"), info_alias, manager->info->alias, 0, 2, 1, labelSizes1);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("ID:"), info_uin, manager->info->formattedID, 2, 4, 1, labelSizes2);	
	gtk_editable_set_editable(GTK_EDITABLE(info_uin), FALSE);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Status:"), info_constate, uu_getStatusDescription(manager->info->status), 0, 2, 2, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_constate), FALSE);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("IP:"), info_ip, manager->info->formattedIP, 2, 4, 2, labelSizes2);
	gtk_editable_set_editable(GTK_EDITABLE(info_ip), FALSE);
	
	info_keepalias = gtk_check_button_new_with_label(tr("Keep alias on update"));
	if (!manager->parentUser->owner)
		gtk_widget_set_no_show_all(info_keepalias, TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info_keepalias), manager->info->keepAlias);
	gtk_table_attach_defaults(GTK_TABLE(table), info_keepalias, 1, 4, 3, 4);


	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);


	// Address
	UIT_CREATE_SECTION_T("Address", table, 4, 3);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Street:"), info_address, manager->info->home.address, 0, 4, 0, labelSizes1);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Zip:"), info_zip, manager->info->home.zip, 0, 2, 1, labelSizes1);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("City:"), info_city, manager->info->home.city, 2, 4, 1, labelSizes2);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("State:"), info_state, manager->info->home.state, 0, 2, 2, labelSizes1);
	UIT_MAKE_LIST_BOX(info_country, manager->info->home.country, NUM_COUNTRIES, gCountries);
	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Country:"), info_country, 2, 4, 2, labelSizes2);


	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	
	
	
	// Contact
	UIT_CREATE_SECTION_T("Contact", table, 4, 4);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Phone:"), info_tel, manager->info->home.phone, 0, 2, 0, labelSizes1);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Fax:"), info_fax, manager->info->home.fax, 2, 4, 0, labelSizes2);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Mobile:"), info_mobile, manager->info->home.mobile, 0, 4, 1, labelSizes1);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Email 1:"), info_email1, manager->info->email1, 0, 4, 2, labelSizes1);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Email 2:"), info_email2, manager->info->email2, 0, 2, 3, labelSizes1);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Email 3:"), info_emailold, manager->info->email3, 2, 4, 3, labelSizes1);


	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);

	
	

/*	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Alias:"), info_alias, manager->info->alias, 0, 2, 0);
	info_keepalias = gtk_check_button_new_with_label(tr("Keep alias on update"));
	if (!manager->parentUser->owner)
		gtk_widget_set_no_show_all(info_keepalias, TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info_keepalias), manager->info->keepAlias);
	gtk_table_attach_defaults(GTK_TABLE(table), info_keepalias, 2, 4, 0, 1);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ID:"), info_uin, manager->info->formattedID, 0, 2, 1);
	gtk_editable_set_editable(GTK_EDITABLE(info_uin), FALSE);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("IP:"), info_ip, manager->info->formattedIP, 2, 4, 1);
	gtk_editable_set_editable(GTK_EDITABLE(info_ip), FALSE);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Status:"), info_constate, uu_getStatusDescription(manager->info->status), 0, 2, 2);
	tmp = g_strdup_printf("GMT%+d00", -manager->info->gmtoffset/3600);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Time zone:"), info_timezone, tmp, 2, 4, 2);
	g_free(tmp);
	gtk_editable_set_editable(GTK_EDITABLE(info_timezone), FALSE);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Name:"), info_name1, manager->info->firstname, 0, 2, 3);
	info_name2 = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(info_name2), manager->info->lastname);
	gtk_table_attach_defaults(GTK_TABLE(table), info_name2, 2, 4, 3, 4);
*/


	
	
	return mainVBox;
	
/*
	
	GtkWidget	*table,
				*label,
				*alignment;
	gchar		*tmp;
	GtkSizeGroup	*sizes;
	
	sizes = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
		
	table = gtk_table_new(11, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table), 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Alias:"), info_alias, manager->info->alias, 0, 2, 0);
	info_keepalias = gtk_check_button_new_with_label(tr("Keep alias on update"));
	if (!manager->parentUser->owner)
		gtk_widget_set_no_show_all(info_keepalias, TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info_keepalias), manager->info->keepAlias);
	gtk_table_attach_defaults(GTK_TABLE(table), info_keepalias, 2, 4, 0, 1);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ID:"), info_uin, manager->info->formattedID, 0, 2, 1);
	gtk_editable_set_editable(GTK_EDITABLE(info_uin), FALSE);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("IP:"), info_ip, manager->info->formattedIP, 2, 4, 1);
	gtk_editable_set_editable(GTK_EDITABLE(info_ip), FALSE);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Status:"), info_constate, uu_getStatusDescription(manager->info->status), 0, 2, 2);
	tmp = g_strdup_printf("GMT%+d00", -manager->info->gmtoffset/3600);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Time zone:"), info_timezone, tmp, 2, 4, 2);
	g_free(tmp);
	gtk_editable_set_editable(GTK_EDITABLE(info_timezone), FALSE);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Name:"), info_name1, manager->info->firstname, 0, 2, 3);
	info_name2 = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(info_name2), manager->info->lastname);
	gtk_table_attach_defaults(GTK_TABLE(table), info_name2, 2, 4, 3, 4);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Email 1:"), info_email1, manager->info->email1, 0, 4, 4);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Email 2:"), info_email2, manager->info->email2, 0, 4, 5);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Email old:"), info_emailold, manager->info->email3, 0, 4, 6);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Address:"), info_address, manager->info->home.address, 0, 2, 7);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Phone:"), info_tel, manager->info->home.phone, 2, 4, 7);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("State:"), info_state, manager->info->home.state, 0, 2, 8);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Fax:"), info_fax, manager->info->home.fax, 2, 4, 8);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("City:"), info_city, manager->info->home.city, 0, 2, 9);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Mobile:"), info_mobile, manager->info->home.mobile, 2, 4, 9);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ZIP:"), info_zip, manager->info->home.zip, 0, 2, 10);
	UIT_MAKE_LIST_BOX(info_country, manager->info->home.country, NUM_COUNTRIES, gCountries);
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Country:"), info_country, 2, 4, 10);
	
	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 0.0f);
	gtk_container_add(GTK_CONTAINER(alignment), table);
	gtk_container_set_border_width(GTK_CONTAINER(alignment), 5);
	
	return alignment; */	
}


GtkWidget* userInfoWindow::createMoreTab()
{
	GtkWidget		*mainVBox,
					*alignment,
					*label,
					*bdlabel,
					*bmlabel,
					*bylabel,
					*sectionLabel,
					*table,
					*hbox,
					*hbox2,
					*goToButton,
					*frame;
	GtkTooltips		*tips;
	
	GtkSizeGroup	*labelSizes1;
	gchar			*fstr;
	
	labelSizes1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	
	UIT_CREATE_MAINVBOX(mainVBox);
	
	
	// Personal info
	UIT_CREATE_SECTION_T("Personal Information", table, 2, 4);	
	
	info_age = gtk_spin_button_new_with_range(0, 999, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_age), manager->info->age);
	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Age:"), info_age, 0, 2, 0, labelSizes1);
			
	bdlabel = gtk_label_new(tr("Day:"));
	bmlabel = gtk_label_new(tr("Month:"));
	bylabel = gtk_label_new(tr("Year:"));
	info_birthday = gtk_spin_button_new_with_range(1, 31, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthday), manager->info->birthday.day);
	info_birthmonth = gtk_spin_button_new_with_range(1, 12, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthmonth), manager->info->birthday.month);
	info_birthyear	= gtk_spin_button_new_with_range(1900, 1900+0xFF, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthyear), manager->info->birthday.year);
	hbox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox), bdlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthday, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), bmlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthmonth, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), bylabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthyear, FALSE, FALSE, 0);

	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Birthday:"), hbox, 0, 2, 1, labelSizes1);	


	info_gender = gtk_combo_box_new_text();
	gtk_widget_set_size_request(info_gender, 100, -1);
	
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Not specified"));
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Female"));
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Male"));
	gtk_combo_box_set_active(GTK_COMBO_BOX(info_gender), manager->info->gender);

	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Gender:"), info_gender, 0, 2, 2, labelSizes1);



	hbox = gtk_hbox_new(FALSE, 2);
		
	UIT_MAKE_LIST_BOX(info_language1, manager->info->language1, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_LIST_BOX(info_language2, manager->info->language2, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_LIST_BOX(info_language3, manager->info->language3, NUM_LANGUAGES, gLanguages);
	
	gtk_box_pack_start(GTK_BOX(hbox), info_language1, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_language2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_language3, TRUE, TRUE, 0);

	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Languages:"), hbox, 0, 2, 3, labelSizes1);

	
	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	


	// Homepage
	UIT_CREATE_SECTION_T("Homepage", table, 2, 3);

	// UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Address:"), info_isite, manager->info->website, 0, 2, 0, labelSizes1);

	label = gtk_label_new(tr("Address:"));
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
													
	info_isite = gtk_entry_new();								
	gtk_entry_set_text(GTK_ENTRY(info_isite), manager->info->website);				
	gtk_widget_set_size_request(info_isite, 100, -1);	

	goToButton = u_createStockImageButton(GTK_STOCK_JUMP_TO);
	g_signal_connect_swapped(goToButton, "clicked", G_CALLBACK(this->cb_openURLButtonClicked), this);
	if (!*manager->info->website)
		gtk_widget_set_sensitive(goToButton, FALSE);
	
	hbox2 = gtk_hbox_new(FALSE, 1);
	gtk_box_pack_start(GTK_BOX(hbox2), info_isite, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox2), goToButton, FALSE, FALSE, 0);
	
																	
	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1, GTK_FILL, GTK_FILL, 0, 0);	
	gtk_table_attach_defaults(GTK_TABLE(table), hbox2, 1, 2, 0, 1);

	gtk_size_group_add_widget(labelSizes1, label);
	
	tips = gtk_tooltips_new();
	gtk_tooltips_set_tip(tips, goToButton, tr("Open the URL"), "");


	info_isitecat = gtk_tree_view_new();
	frame = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(frame), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(frame), GTK_SHADOW_IN);
	gtk_container_add(GTK_CONTAINER(frame), info_isitecat);
	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Category:"), frame, 0, 2, 1, labelSizes1);	
	
	frame = u_createTextView(&info_isitedescr);
	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Description:"), frame, 0, 2, 2, labelSizes1);
	
	
	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);	
	
	
	
	return mainVBox;
	
/*
	GtkWidget	*table,
				*label,
				*alignment,
				*bdlabel,
				*bmlabel,
				*bylabel,
				*hbox;
	GtkSizeGroup	*sizes;
	
	sizes = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	table = gtk_table_new(4, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table), 5);
	
	
	info_age = gtk_spin_button_new_with_range(0, 999, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_age), manager->info->age);

	
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Age:"), info_age, 0, 2, 0);
		
	info_gender = gtk_combo_box_new_text();
	gtk_widget_set_size_request(info_gender, 100, -1);
	
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Not specified"));
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Female"));
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Male"));
	gtk_combo_box_set_active(GTK_COMBO_BOX(info_gender), manager->info->gender);
	
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Gender:"), info_gender, 2, 4, 0);
	
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Web page:"), info_isite, manager->info->website, 0, 4, 1);
	
	
	bdlabel = gtk_label_new(tr("Day:"));
	bmlabel = gtk_label_new(tr("Month:"));
	bylabel = gtk_label_new(tr("Year:"));
	info_birthday = gtk_spin_button_new_with_range(1, 31, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthday), manager->info->birthday.day);
	info_birthmonth = gtk_spin_button_new_with_range(1, 12, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthmonth), manager->info->birthday.month);
	info_birthyear	= gtk_spin_button_new_with_range(1900, 1900+0xFF, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthyear), manager->info->birthday.year);
	hbox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox), bdlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthday, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), bmlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthmonth, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), bylabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthyear, FALSE, FALSE, 0);

	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Birthday:"), hbox, 0, 4, 2);


	
	hbox = gtk_hbox_new(FALSE, 2);
	
	
	UIT_MAKE_LIST_BOX(info_language1, manager->info->language1, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_LIST_BOX(info_language2, manager->info->language2, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_LIST_BOX(info_language3, manager->info->language3, NUM_LANGUAGES, gLanguages);
	
	gtk_box_pack_start(GTK_BOX(hbox), info_language1, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_language2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_language3, TRUE, TRUE, 0);

	
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Languages:"), hbox, 0, 4, 3);
	
	
	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 0.0f);
	gtk_container_add(GTK_CONTAINER(alignment), table);
	gtk_container_set_border_width(GTK_CONTAINER(alignment), 5);
	
	return alignment; */
}




GtkWidget* userInfoWindow::createWorkTab()
{
	GtkWidget		*mainVBox,
					*label,
					*alignment,
					*sectionLabel,
					*table;
	
	GtkSizeGroup	*labelSizes1, 
					*labelSizes2;
	gchar			*fstr;
	
	
	labelSizes1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	labelSizes2 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	
	UIT_CREATE_MAINVBOX(mainVBox);
	
	
	// general work information
	UIT_CREATE_SECTION_T("General Information", table, 4, 3);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Occupation:"), info_companyOcc, "", 0, 4, 0, labelSizes1);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Name:"), info_companyName, manager->info->company.name, 0, 4, 1, labelSizes1);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Department:"), info_companyDep, manager->info->company.department, 0, 2, 2, labelSizes1);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Position:"), info_companyPos, manager->info->company.position, 2, 4, 2, labelSizes2);
	
	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	
	
	
	// Address
	UIT_CREATE_SECTION_T("Address", table, 4, 3);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Street:"), info_companyAddress, manager->info->company.address, 0, 4, 0, labelSizes1);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Zip:"), info_companyZip, manager->info->company.zip, 0, 2, 1, labelSizes1);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("City:"), info_companyCity, manager->info->company.city, 2, 4, 1, labelSizes2);

	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("State:"), info_companyState, manager->info->company.state, 0, 2, 2, labelSizes1);
	UIT_MAKE_LIST_BOX(info_companyCountry, manager->info->company.country, NUM_COUNTRIES, gCountries);
	UIT_CREATE_TABLE_ROW_CUSTOM_S(table, tr("Country:"), info_companyCountry, 2, 4, 2, labelSizes2);


	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	
	
	
	// Contact
	UIT_CREATE_SECTION_T("Contact", table, 2, 3);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Phone:"), info_companyTel, manager->info->company.phone, 0, 2, 1, labelSizes1);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Fax:"), info_companyFax, manager->info->company.fax, 0, 2, 2, labelSizes1);	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Web Page:"), info_companyISite, manager->info->company.website, 0, 2, 0, labelSizes1);
	

	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	
	return mainVBox;
	

/*
	GtkWidget	*table,
				*label,
				*alignment;
	GtkSizeGroup	*sizes;
	
	sizes = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	table = gtk_table_new(11, 7, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table), 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Name:"), info_companyName, manager->info->company.name, 0, 4, 0);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Department:"), info_companyDep, manager->info->company.department, 0, 2, 1);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Position:"), info_companyPos, manager->info->company.position, 2, 4, 1);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("City:"), info_companyCity, manager->info->company.city, 0, 2, 2);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("State:"), info_companyState, manager->info->company.state, 2, 4, 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Address:"), info_companyAddress, manager->info->company.address, 0, 4, 3);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ZIP:"), info_companyZip, manager->info->company.zip, 0, 2, 4);
	UIT_MAKE_LIST_BOX(info_companyCountry, manager->info->company.country, NUM_COUNTRIES, gCountries);
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Country:"), info_companyCountry, 2, 4, 4);

	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Phone:"), info_companyTel, manager->info->company.phone, 0, 2, 5);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Fax:"), info_companyFax, manager->info->company.fax, 2, 4, 5);

	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Web page:"), info_companyISite, manager->info->company.website, 0, 4, 6);


	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 0.0f);
	gtk_container_add(GTK_CONTAINER(alignment), table);
	gtk_container_set_border_width(GTK_CONTAINER(alignment), 5);
	
	return alignment; */
}


GtkWidget* userInfoWindow::createAboutTab()
{
	GtkWidget		*aboutframe;
	GtkTextIter 	start;
	GtkTextBuffer	*buf;
	
	aboutframe = u_createTextView(&info_about);
	
	buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(info_about));
	
	gtk_text_buffer_get_start_iter(buf, &start);
	
	gtk_text_buffer_insert(buf, &start, manager->info->about, strlen(manager->info->about));
	
	gtk_container_set_border_width(GTK_CONTAINER(aboutframe), 5);
	
	return aboutframe;
}


GtkWidget* userInfoWindow::createLastTab()
{
	GtkWidget	*mainVBox,
				*label,
				*alignment,
				*sectionLabel,
				*table;
	
	GtkSizeGroup	*labelSizes1;
	gchar			*fstr;
	
	labelSizes1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	UIT_CREATE_MAINVBOX(mainVBox);
	
	// user status
	UIT_CREATE_SECTION_T(tr("User status"), table, 2, 3);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Last online:"), info_lastOnline, "", 0, 2, 0, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_lastOnline), FALSE);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Online since:"), info_onlineSince, "", 0, 2, 1, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_onlineSince), FALSE);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Idle since:"), info_idleSince, "", 0, 2, 2, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_idleSince), FALSE);
	
	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	
	
	// user actions
	UIT_CREATE_SECTION_T(tr("User actions"), table, 2, 3);
	
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Last sent event:"), info_lastSent, "", 0, 2, 0, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_lastSent), FALSE);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Last received event:"), info_lastReceived, "", 0, 2, 1, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_lastReceived), FALSE);
	UIT_CREATE_TABLE_ROW_ENTRY_S(table, tr("Last checked auto response:"), info_lastAR, "", 0, 2, 2, labelSizes1);
	gtk_editable_set_editable(GTK_EDITABLE(info_lastAR), FALSE);

	
	gtk_box_pack_start(GTK_BOX(mainVBox), sectionLabel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), alignment, FALSE, TRUE, 0);
	
	
	insertLastInfo();
	
	return mainVBox;
}

#define UIT_INSERT_LAST_INFO(inf, w)						\
	if (manager->info->stats.inf)							\
	{														\
		strftime(ftime, 128, tr("%a, %d.%m.%y  %H:%M:%S"), localtime(&manager->info->stats.inf)); \
		tmp = g_strdup(ftime);								\
	} else													\
		tmp = g_strdup(tr("Unknown"));						\
	gtk_entry_set_text(GTK_ENTRY(w), tmp);					\
	g_free(tmp);

void userInfoWindow::insertLastInfo()
{
	gchar		*tmp;
	gchar		ftime[128] = {0, };


	// last online
	if (manager->info->status!=BUDDY_STATUS_OFFLINE)
		tmp = g_strdup(tr("Now"));
	else
	{
		strftime(ftime, 128, tr("%a, %d.%m.%y  %H:%M:%S"), localtime(&manager->info->stats.lastOnline));
		tmp = g_strdup(ftime);
	}
	gtk_entry_set_text(GTK_ENTRY(info_lastOnline), tmp);
	g_free(tmp);

	// online since
	if (manager->info->status==BUDDY_STATUS_OFFLINE)
		tmp = g_strdup(tr("User is offline"));
	else
	{
		strftime(ftime, 128, tr("%a, %d.%m.%y  %H:%M:%S"), localtime(&manager->info->stats.onlineSince));
		tmp = g_strdup(ftime);		
	}
	gtk_entry_set_text(GTK_ENTRY(info_onlineSince), tmp);
	g_free(tmp);

	UIT_INSERT_LAST_INFO(idleSince, info_idleSince);
	UIT_INSERT_LAST_INFO(lastSent, info_lastSent);
	UIT_INSERT_LAST_INFO(lastReceived, info_lastReceived);
	UIT_INSERT_LAST_INFO(lastAR, info_lastAR);	
}


GtkWidget* userInfoWindow::createInterestsTab()
{
	GtkWidget			*mainVBox,
						*frame,
						*hbox;
	GtkSizeGroup		*labelSizes1;
	
	GtkCellRenderer		*renderer;
	
	
	
	labelSizes1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
	
	UIT_CREATE_MAINVBOX(mainVBox);
	
	// create the edit buttons
	addInterestButton = u_createStockImageButton(GTK_STOCK_ADD);
	g_signal_connect_swapped(addInterestButton, "clicked", G_CALLBACK(this->cb_addInterestButtonClicked), this);
	removeInterestButton = u_createStockImageButton(GTK_STOCK_REMOVE);
	g_signal_connect_swapped(removeInterestButton, "clicked", G_CALLBACK(this->cb_removeInterestButtonClicked), this);
	editInterestButton = u_createStockImageButton(GTK_STOCK_JUSTIFY_LEFT);
	g_signal_connect_swapped(editInterestButton, "clicked", G_CALLBACK(this->cb_editInterestButtonClicked), this);
	
	hbox = gtk_hbox_new(FALSE, 1);
	gtk_box_pack_start(GTK_BOX(hbox), addInterestButton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), removeInterestButton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), editInterestButton, FALSE, FALSE, 0);

	
	// create the interests view
	info_interestsView = gtk_tree_view_new();
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(info_interestsView), FALSE);
	g_signal_connect_swapped(info_interestsView, "row-activated", G_CALLBACK(this->cb_editInterestButtonClicked), this);
	g_signal_connect_swapped(gtk_tree_view_get_selection(GTK_TREE_VIEW(info_interestsView)), "changed", G_CALLBACK(this->cb_interestsCursorChanged), this);

	renderer = gtk_cell_renderer_text_new();
	g_signal_connect(renderer, "edited", G_CALLBACK(this->cb_interestEdited), this);
	interestsColumn = gtk_tree_view_column_new_with_attributes("", renderer, 
																"markup", IE_NAME,
																"editable", IE_EDITABLE,																
																NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(info_interestsView), interestsColumn);
	
	frame = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(frame), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(frame), GTK_SHADOW_IN);
	gtk_container_add(GTK_CONTAINER(frame), info_interestsView);
	
	//										name			type		layer		num			list
	interestsStore = gtk_tree_store_new(6, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_POINTER, G_TYPE_BOOLEAN);
	gtk_tree_view_set_model(GTK_TREE_VIEW(info_interestsView), GTK_TREE_MODEL(interestsStore));
	
	updateInterestsCategory(tr("Interests"), manager->info->interests, CAT_INTERESTS);
	updateInterestsCategory(tr("Organizations"), manager->info->organizations, CAT_ORGANIZATION);	
	updateInterestsCategory(tr("Past / Backgrounds"), manager->info->background, CAT_BACKGROUND);	
	
	
	gtk_box_pack_start(GTK_BOX(mainVBox), frame, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mainVBox), hbox, FALSE, FALSE, 0);
	
	cb_interestsCursorChanged(this);
		
	return mainVBox;
}



void userInfoWindow::updateInterestsCategory(gchar* headline, GList* list, gint catID)
{
	GList			*searchc,
					*searche;
	
	GtkTreeIter		iter1,
					iter2,
					hliter;
	gint			i;
	
	gchar			*tmp,
					*fstr;
	GtkTreePath		*path;
	
	IMUserListInfo	*userCat;

	
	fstr = g_strdup_printf("<b>%s</b>", headline);
	
	gtk_tree_store_append(interestsStore, &hliter, NULL);
	gtk_tree_store_set(interestsStore, &hliter, 
						IE_NAME, fstr, 
						IE_TYPE, catID,
						IE_LAYER, 0,
						IE_NUM, g_list_length(list),
						IE_LIST, list,
						IE_EDITABLE, FALSE,
						-1);

	g_free(fstr);
	
	searchc = list;
	i = 0;
	while(searchc)
	{
		userCat = (IMUserListInfo*)searchc->data;
		gtk_tree_store_append(interestsStore, &iter1, &hliter);
		tmp = g_strdup_printf("<i>%s</i>", userCat->headline);
		gtk_tree_store_set(interestsStore, &iter1, 
							IE_NAME, tmp, 
							IE_TYPE, catID,
							IE_LAYER, 1,
							IE_NUM, userCat->headlineNumber,
							IE_LIST, list,
							IE_EDITABLE, FALSE,
							-1);
		g_free(tmp);
		
		searche = userCat->entries;
		while(searche)
		{
			gtk_tree_store_append(interestsStore, &iter2, &iter1);
			tmp = g_markup_escape_text((const gchar*)searche->data, strlen((gchar*)searche->data));
			gtk_tree_store_set(interestsStore, &iter2, 
								IE_NAME, tmp, 
								IE_TYPE, catID,
								IE_LAYER, 2,
								IE_NUM, i, 
								IE_LIST, list,
								IE_EDITABLE, TRUE,
								-1);
			g_free(tmp);
			searche = searche->next;
		} 
		
		i++;
		searchc = searchc->next;
	}	
		
	path = gtk_tree_model_get_path(GTK_TREE_MODEL(interestsStore), &hliter);
	
	gtk_tree_view_expand_row(GTK_TREE_VIEW(info_interestsView), path, TRUE);
	
	gtk_tree_path_free(path);
}



SCategory* userInfoWindow::getNewCategory(const SCategory* cats, guint num, gboolean add)
{
	GtkWidget			*catWin,
						*catView,
						*catFrame,
						*vbox,
						*label;
	GtkListStore		*store;
	GtkTreeIter			iter;
	GtkTreePath			*path;
	guint				i;
	gint				result;
	GtkTreeViewColumn	*col;
	GtkCellRenderer		*renderer;
	SCategory			*toReturn;
	gchar				*fstr;
	
	// create the store
	store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_POINTER);
	for (i=0; i<num; i++)
	{
		gtk_list_store_append(store, &iter);
		gtk_list_store_set(store, &iter,
							0, cats[i].szName,
							1, &cats[i],
							-1);
	}
	
	
	// create the view
	catView = gtk_tree_view_new_with_model(GTK_TREE_MODEL(store));
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(catView), FALSE);
	
	renderer = gtk_cell_renderer_text_new();
	col = gtk_tree_view_column_new_with_attributes("", renderer, "text", 0, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(catView), col);
	
	catFrame = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(catFrame), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(catFrame), GTK_SHADOW_IN);
	gtk_container_add(GTK_CONTAINER(catFrame), catView);
	
	// create the label
	label = gtk_label_new(NULL);
	if (add)
	{
		fstr = g_strdup_printf("<small>%s</small>", tr("Please select a category to add."));
		gtk_label_set_markup(GTK_LABEL(label), fstr);
		g_free(fstr);
	}
	else
	{
		fstr = g_strdup_printf("<small>%s</small>", tr("Please select a category to replace the existing with. Remember that the category entries may not fit then anymore."));
		gtk_label_set_markup(GTK_LABEL(label), fstr);
		g_free(fstr);
	}
	gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.0f);
	
	
	// create a vbox
	vbox = gtk_vbox_new(FALSE, 2);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), catFrame, TRUE, TRUE, 0);
	
	
	// create the dialog
	catWin = gtk_dialog_new_with_buttons(tr("Select a category"), 
										 GTK_WINDOW(window),
	 									 (GtkDialogFlags)(GTK_DIALOG_MODAL |  GTK_DIALOG_DESTROY_WITH_PARENT),
										 GTK_STOCK_OK,
										 GTK_RESPONSE_OK,
										 GTK_STOCK_CANCEL,
										 GTK_RESPONSE_CANCEL,
										 NULL);
										 
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(catWin)->vbox), vbox);
	gtk_window_set_default_size(GTK_WINDOW(catWin), 300, 300);	
	gtk_widget_show_all(catWin);
	
	// add a callback for clicking the list
	g_signal_connect_swapped(catView, "row-activated", G_CALLBACK(this->cb_newCatWindowListActivated), catWin);
	

	result = gtk_dialog_run(GTK_DIALOG(catWin));
	
	toReturn = NULL;
	if (result == GTK_RESPONSE_OK)
	{
		gtk_tree_view_get_cursor(GTK_TREE_VIEW(catView), &path, NULL);
	
		if (path)
		{
			gtk_tree_model_get_iter(GTK_TREE_MODEL(store), &iter, path);
			gtk_tree_model_get(GTK_TREE_MODEL(store), &iter,
								1, &toReturn,
								-1);
			
			gtk_tree_path_free(path);			
		}
	}
	
	gtk_widget_destroy(catWin);
	
	return toReturn;
}


GList* userInfoWindow::recreateInterestsList(GtkTreeIter* iter)
{
	GtkTreePath		*path;
	GtkTreeIter		iter1,
					iter2;
	GList			*toReturn;
	gint			code;
	IMUserListInfo	*listInfo;
	gchar			*tmp;
	
	toReturn = NULL;
	
	if (!gtk_tree_model_iter_has_child(GTK_TREE_MODEL(interestsStore), iter))
		return NULL;
		
	gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(interestsStore), &iter1, iter, 0);
	
	do
	{
		listInfo = (IMUserListInfo*)g_malloc0(sizeof(IMUserListInfo));
		gtk_tree_model_get(GTK_TREE_MODEL(interestsStore), &iter1,
						   IE_NUM, &code,
						   -1);
		listInfo->headlineNumber = code;
		
		if (gtk_tree_model_iter_has_child(GTK_TREE_MODEL(interestsStore), &iter1))
		{
			gtk_tree_model_iter_nth_child(GTK_TREE_MODEL(interestsStore), &iter2, &iter1, 0);
			do
			{
				gtk_tree_model_get(GTK_TREE_MODEL(interestsStore), &iter2,
									IE_NAME, &tmp,
									-1);
				listInfo->entries = g_list_append(listInfo->entries, g_strdup(tmp));
			} while(gtk_tree_model_iter_next(GTK_TREE_MODEL(interestsStore), &iter2));	
		}
		
		toReturn = g_list_append(toReturn, listInfo);
		
	} while (gtk_tree_model_iter_next(GTK_TREE_MODEL(interestsStore), &iter1));
	
	path = gtk_tree_model_get_path(GTK_TREE_MODEL(interestsStore), iter);
	gtk_tree_path_append_index(path, 0);
	
	return toReturn;
}




void userInfoWindow::destroyWindowContent()
{
	stopUpdate();
}


		
gboolean userInfoWindow::eventCallback(gint comment, gint lastResult, gpointer info)
{
	switch(comment)
	{
		case UC_EVENT_FINISHED:

			stopUpdate();
		
			if (lastResult != EVENT_RESULT_ACKED && lastResult != EVENT_RESULT_SUCCESS)
				uu_showSendErrorMessage(tr("Could not update"), tr("Updating of the user failed"), lastResult, manager->parentUser->owner? manager->parentUser->owner->info->status: manager->parentUser->info->status);
			else
			if (((IMUserUpdateManager*)manager)->sendUpdateStep == 0)
				shiftInformation(TRUE);
			break; 
	}
	
	return TRUE;
}




void userInfoWindow::startUpdate()
{
	gtk_widget_set_sensitive(notebook, FALSE);
	gtk_widget_set_sensitive(saveBtn, FALSE);
	gtk_widget_set_sensitive(updateBtn, FALSE);
	if (!manager->parentUser->owner)
		gtk_widget_set_sensitive(sendBtn, FALSE);
	
	gtk_button_set_label(GTK_BUTTON(closeBtn), GTK_STOCK_CANCEL);
	gtk_button_set_use_stock(GTK_BUTTON(closeBtn), TRUE);
	
	sendAni->play();
}



void userInfoWindow::stopUpdate()
{	
	gtk_widget_set_sensitive(notebook, TRUE);
	gtk_widget_set_sensitive(saveBtn, TRUE);
	gtk_widget_set_sensitive(updateBtn, TRUE);
	if (!manager->parentUser->owner)
		gtk_widget_set_sensitive(sendBtn, TRUE);
	
	gtk_button_set_label(GTK_BUTTON(closeBtn), GTK_STOCK_CLOSE);
	gtk_button_set_use_stock(GTK_BUTTON(closeBtn), TRUE);	
	sendAni->stop();
	
	manager->cancelInitatedEvent();
}






#define UIWT_SHIFTINFO_ENTRY(uinf, entry)										\
	if (!update && gtk_editable_get_editable(GTK_EDITABLE(entry)))				\
	{																			\
		g_free(manager->info->uinf);											\
		manager->info->uinf = g_strdup(gtk_entry_get_text(GTK_ENTRY(entry)));	\
	} else																		\
		gtk_entry_set_text(GTK_ENTRY(entry), manager->info->uinf);

	
#define UIWT_SHIFTINFO_SPIN(uinf, spin)											\
	if (update)																	\
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin), manager->info->uinf);	\
	else																		\
		manager->info->uinf = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin));
	

#define UIWT_SHIFTINFO_COMBO(uinf, combo)										\
	if (update)																	\
		gtk_combo_box_set_active(GTK_COMBO_BOX(combo), manager->info->uinf);	\
	else																		\
		manager->info->uinf = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));


void userInfoWindow::shiftInformation(gboolean update)
{
	GtkTextBuffer*	buf;
	GtkTextIter		start, end;
	GList			*list1,
					*list2,
					*list3;
	GtkTreeIter		iter;
	gint			interestType;
	
	// general
	if (!g_list_nth_data(tabs, 0))
	{
		UIWT_SHIFTINFO_ENTRY(alias, info_alias);
		if (update)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info_keepalias), manager->info->keepAlias);
		else
			manager->info->keepAlias = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(info_keepalias));
		UIWT_SHIFTINFO_ENTRY(firstname, info_name1);
		UIWT_SHIFTINFO_ENTRY(lastname, info_name2);
		UIWT_SHIFTINFO_ENTRY(formattedID, info_uin);
		UIWT_SHIFTINFO_ENTRY(formattedIP, info_ip);
		UIWT_SHIFTINFO_ENTRY(email1, info_email1);
		UIWT_SHIFTINFO_ENTRY(email2, info_email2);
		UIWT_SHIFTINFO_ENTRY(email3, info_emailold);
		UIWT_SHIFTINFO_ENTRY(home.address, info_address);
		UIWT_SHIFTINFO_ENTRY(home.phone, info_tel);
		UIWT_SHIFTINFO_ENTRY(home.state, info_state);
		UIWT_SHIFTINFO_ENTRY(home.fax, info_fax);
		UIWT_SHIFTINFO_ENTRY(home.city, info_city);
		UIWT_SHIFTINFO_ENTRY(home.mobile, info_mobile);
	}


	if (!g_list_nth_data(tabs, 1))
	{
		// more	
		UIWT_SHIFTINFO_SPIN(age, info_age);
		UIWT_SHIFTINFO_COMBO(gender, info_gender);
		UIWT_SHIFTINFO_SPIN(birthday.day, info_birthday);
		UIWT_SHIFTINFO_SPIN(birthday.month, info_birthmonth);
		UIWT_SHIFTINFO_SPIN(birthday.year, info_birthyear);
		UIWT_SHIFTINFO_ENTRY(website, info_isite);
		
		UIWT_SHIFTINFO_COMBO(language1, info_language1);
		UIWT_SHIFTINFO_COMBO(language2, info_language2);
		UIWT_SHIFTINFO_COMBO(language3, info_language3);
	}
	
	if (!g_list_nth_data(tabs, 2))
	{
		if (update)
		{
			gtk_tree_store_clear(interestsStore);
			updateInterestsCategory(tr("Interests"), manager->info->interests, CAT_INTERESTS);
			updateInterestsCategory(tr("Organizations"), manager->info->organizations, CAT_ORGANIZATION);			
			updateInterestsCategory(tr("Past / Backgrounds"), manager->info->background, CAT_BACKGROUND);		
		} else
		// recreate the list
		{
			list1 = NULL;
			list2 = NULL;
			list3 = NULL;
			
			gtk_tree_model_get_iter_first(GTK_TREE_MODEL(interestsStore), &iter);
			do
			{
				gtk_tree_model_get(GTK_TREE_MODEL(interestsStore), &iter,
									IE_TYPE, &interestType,
									-1);
			
				switch(interestType)
				{
					case CAT_INTERESTS: list1 = recreateInterestsList(&iter); break;
					case CAT_BACKGROUND: list2 = recreateInterestsList(&iter); break;
					case CAT_ORGANIZATION: list3 = recreateInterestsList(&iter); break;
				}
			} while (gtk_tree_model_iter_next(GTK_TREE_MODEL(interestsStore), &iter));
		
			manager->parentUser->clearUserInfoCategories(manager->info->interests);
			manager->info->interests = list1;
			manager->parentUser->clearUserInfoCategories(manager->info->background);
			manager->info->background = list2;
			manager->parentUser->clearUserInfoCategories(manager->info->organizations);
			manager->info->organizations = list3;
		}
	}
	
	
	if (!g_list_nth_data(tabs, 3))
	{
		// work
		UIWT_SHIFTINFO_ENTRY(company.name, info_companyName);
		UIWT_SHIFTINFO_ENTRY(company.department, info_companyDep);
		UIWT_SHIFTINFO_ENTRY(company.position, info_companyPos);
		UIWT_SHIFTINFO_ENTRY(company.city, info_companyCity);
		UIWT_SHIFTINFO_ENTRY(company.state, info_companyState);
		UIWT_SHIFTINFO_ENTRY(company.address, info_companyAddress);
		UIWT_SHIFTINFO_ENTRY(company.zip, info_companyZip);
		// country
		UIWT_SHIFTINFO_ENTRY(company.phone, info_companyTel);
		UIWT_SHIFTINFO_ENTRY(company.fax, info_companyFax);
		UIWT_SHIFTINFO_ENTRY(company.website, info_companyISite);
	}


	if (!g_list_nth_data(tabs, 4))
	{
		// about	
		buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(info_about));

		if (update)
		{
			gtk_text_buffer_set_text(buf, manager->info->about, strlen(manager->info->about));
		} else
		{
			gtk_text_buffer_get_bounds(buf, &start, &end);		
			g_free(manager->info->about);
			manager->info->about = gtk_text_buffer_get_text(buf, &start, &end, FALSE);
		}
	}
	
	if (!g_list_nth_data(tabs, 5) && update)
		insertLastInfo();
}


void userInfoWindow::escPressed()
{
	cb_closeButtonClicked(this);
}



void userInfoWindow::cb_updateButtonClicked(userInfoWindow* uiw)
{
	uiw->startUpdate();
		
	if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(uiw->info_keepalias)))
		((IMUserUpdateManager*)uiw->manager)->updateUserInfo(NULL);
	else
		((IMUserUpdateManager*)uiw->manager)->updateUserInfo((gchar*)gtk_entry_get_text(GTK_ENTRY(uiw->info_alias)));		
}


void userInfoWindow::cb_sendButtonClicked(userInfoWindow* uiw)
{
	uiw->shiftInformation(FALSE);
	uiw->startUpdate();
		
	((IMUserUpdateManager*)uiw->manager)->sendUserInfo();
}



void userInfoWindow::cb_closeButtonClicked(userInfoWindow* uiw)
{
	if (uiw->manager->isProcessing)
		uiw->stopUpdate();
	else
	{
		uiw->destroyWindow();
		delete uiw;
	}
}


void userInfoWindow::cb_saveButtonClicked(userInfoWindow* uiw)
{
	uiw->shiftInformation(FALSE);
	((IMUserUpdateManager*)uiw->manager)->saveUserInfo();
}




void userInfoWindow::cb_switchTab(GtkWidget *w, GtkNotebookPage *page, guint newTab, userInfoWindow* uiw)
{
	GtkWidget	*box,
				*toadd;
	GList		*tmp;
	
	box = (GtkWidget*)g_list_nth_data(uiw->tabs, newTab);
	
	if (!box)
		return;
	
	if (! (tmp = gtk_container_get_children(GTK_CONTAINER(box))) )
	{
		toadd = NULL;
		
		switch(newTab)
		{
			case 0: toadd = uiw->createGeneralTab(); break;
			case 1: toadd = uiw->createMoreTab(); break;
			case 2: toadd = uiw->createInterestsTab(); break;
			case 3: toadd = uiw->createWorkTab(); break;
			case 4: toadd = uiw->createAboutTab(); break;	
			case 5: toadd = uiw->createLastTab(); break;				
			default: toadd = gtk_label_new("Work is in progress...!\n"); break;				
		}
		
		gtk_container_add(GTK_CONTAINER(box), toadd);
		gtk_widget_show_all(box);
		
		g_list_nth(uiw->tabs, newTab)->data = NULL;
		
	} else
		g_list_free(tmp);
}


void userInfoWindow::cb_newCatWindowListActivated(GtkDialog* dialog)
{
	gtk_dialog_response(dialog, GTK_RESPONSE_OK);
}


void userInfoWindow::cb_addInterestButtonClicked(userInfoWindow* self)
{
	GtkTreePath			*path,
						*path2,
						*path3;
	GtkTreeIter  		iter,
						iter2,
						parentIter;
	gint				catType,
						catNum,
						catLayer;
	gchar				*tmp;
	SCategory			*newCategory;
	
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(self->info_interestsView), &path, NULL);

	if (!path) 
		return;
	
	gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &iter, path);
	
	gtk_tree_model_get(GTK_TREE_MODEL(self->interestsStore), &iter,
						IE_TYPE, &catType,
						IE_NUM, &catNum,
						IE_LAYER, &catLayer,
						-1);
	
	// append a new element
	if (catLayer != 0)
	{
		if (catLayer == 2)
		{
			// get the parent iter
			path2 = gtk_tree_path_copy(path);
			gtk_tree_path_up(path2);
			gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &parentIter, path2);
			gtk_tree_path_free(path2);
		} 
		
		// add and focus the new element
		if (catLayer == 1)
			gtk_tree_store_prepend(self->interestsStore, &iter2, &iter);
		else
			gtk_tree_store_insert_after(self->interestsStore, &iter2, &parentIter, &iter);
		
		gtk_tree_store_set(self->interestsStore, &iter2,
						   IE_TYPE, catType,
						   IE_NAME, "",
						   IE_LAYER, 2,
						   IE_EDITABLE, TRUE,
						   -1);
		
		path2 = gtk_tree_model_get_path(GTK_TREE_MODEL(self->interestsStore), &iter2);
		
		path3 = gtk_tree_path_copy(path2);
		gtk_tree_path_up(path3);
		gtk_tree_view_expand_row(GTK_TREE_VIEW(self->info_interestsView), path3, TRUE);
		gtk_tree_path_free(path3);
		
		gtk_tree_view_set_cursor(GTK_TREE_VIEW(self->info_interestsView), path2, self->interestsColumn, TRUE);
		
		gtk_tree_path_free(path2);
	}
	else
	{
		// open the categories window
		switch(catType)
		{
			case CAT_INTERESTS: newCategory = self->getNewCategory(gInterests, NUM_INTERESTS, TRUE); break;
			case CAT_BACKGROUND: newCategory = self->getNewCategory(gBackgrounds, NUM_BACKGROUNDS, TRUE); break;
			default: newCategory = self->getNewCategory(gOrganizations, NUM_ORGANIZATIONS, TRUE); break;
		}
		
		if (newCategory)
		{
			gtk_tree_store_append(self->interestsStore, &iter2, &iter);
			tmp = g_strdup_printf("<i>%s</i>", newCategory->szName);
			gtk_tree_store_set(self->interestsStore, &iter2,
								IE_NAME, tmp,
								IE_TYPE, catType,
								IE_LAYER, 1,
								IE_NUM, newCategory->nCode,
								IE_EDITABLE, FALSE,
								-1);
			g_free(tmp);
			
			path2 = gtk_tree_model_get_path(GTK_TREE_MODEL(self->interestsStore), &iter2);

			path3 = gtk_tree_path_copy(path2);
			gtk_tree_path_up(path3);
			gtk_tree_view_expand_row(GTK_TREE_VIEW(self->info_interestsView), path3, TRUE);
			gtk_tree_path_free(path3);
			
			gtk_tree_view_set_cursor(GTK_TREE_VIEW(self->info_interestsView), path2, self->interestsColumn, TRUE);
			gtk_tree_path_free(path2);
		}
	}
	
	gtk_tree_path_free(path);	
}


void userInfoWindow::cb_removeInterestButtonClicked(userInfoWindow* self)
{
	GtkTreePath	*path;
	GtkTreeIter	iter;
	
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(self->info_interestsView), &path, NULL);

	if (!path) 
		return;
	
	gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &iter, path);
	
	gtk_tree_store_remove(self->interestsStore, &iter);
	
	gtk_tree_path_free(path);
}


void userInfoWindow::cb_editInterestButtonClicked(userInfoWindow* self)
{
	GtkTreePath			*path;
	GtkTreeIter  		iter;
	gint				catType,
						catNum,
						catLayer;
	gchar				*tmp;
	SCategory			*newCategory;
	
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(self->info_interestsView), &path, NULL);

	if (!path) 
		return;
	
	gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &iter, path);
	
	gtk_tree_model_get(GTK_TREE_MODEL(self->interestsStore), &iter,
						IE_TYPE, &catType,
						IE_NUM, &catNum,
						IE_LAYER, &catLayer,
						-1);
	
	if (catLayer == 2)
		gtk_tree_view_set_cursor(GTK_TREE_VIEW(self->info_interestsView), path, self->interestsColumn, TRUE);
	else
	if (catLayer == 1)
	{
		// open the categories window
		switch(catType)
		{
			case CAT_INTERESTS: newCategory = self->getNewCategory(gInterests, NUM_INTERESTS, FALSE); break;
			case CAT_BACKGROUND: newCategory = self->getNewCategory(gBackgrounds, NUM_BACKGROUNDS, FALSE); break;
			default: newCategory = self->getNewCategory(gOrganizations, NUM_ORGANIZATIONS, FALSE); break;
		}
		
		if (newCategory)
		{
			tmp = g_strdup_printf("<i>%s</i>", newCategory->szName);
			gtk_tree_store_set(self->interestsStore, &iter,
							   IE_NAME, tmp,
							   IE_NUM, newCategory->nCode,
							   -1);
			g_free(tmp);
		}
	}
	
	gtk_tree_path_free(path);	
	
}
	


void userInfoWindow::cb_interestsCursorChanged(userInfoWindow* self)
{
	GtkTreePath	*path;
	GtkTreeIter	iter;
	gint		catLayer,
				catType,
				num;
	
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(self->info_interestsView), &path, NULL);

	if (!path) 
	{
		gtk_widget_set_sensitive(self->addInterestButton, FALSE);
		gtk_widget_set_sensitive(self->removeInterestButton, FALSE);
		gtk_widget_set_sensitive(self->editInterestButton, FALSE);
		return;
	}
	
	gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &iter, path);
	
	gtk_tree_model_get(GTK_TREE_MODEL(self->interestsStore), &iter,
						IE_TYPE, &catType,
						IE_LAYER, &catLayer,
						-1);	
	
	if (!catLayer)
	{
		// check whether new entries can be added		
		gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &iter, path);
		num = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(self->interestsStore), &iter);
		if ( (num>=4 && catType == CAT_INTERESTS) || 
			 (num>=3 && catType == CAT_BACKGROUND) ||
			 (num>=3 && catType == CAT_ORGANIZATION))
			gtk_widget_set_sensitive(self->addInterestButton, FALSE);
		else
			gtk_widget_set_sensitive(self->addInterestButton, TRUE);
		
		gtk_widget_set_sensitive(self->removeInterestButton, FALSE);
		gtk_widget_set_sensitive(self->editInterestButton, FALSE);			
	} else
	{
		gtk_widget_set_sensitive(self->removeInterestButton, TRUE);
		gtk_widget_set_sensitive(self->editInterestButton, TRUE);		
		gtk_widget_set_sensitive(self->addInterestButton, TRUE);
	}
	
	gtk_tree_path_free(path);
}


void userInfoWindow::cb_interestEdited(GtkCellRendererText *cell, gchar *pathStr, gchar *newText, userInfoWindow* self)
{
	GtkTreeIter	iter;
	GtkTreePath	*path;
	
	path = gtk_tree_path_new_from_string(pathStr);
	
	gtk_tree_model_get_iter(GTK_TREE_MODEL(self->interestsStore), &iter, path);
	
	gtk_tree_store_set(self->interestsStore, &iter,
					   IE_NAME, newText,
					   -1);

	gtk_tree_path_free(path);	
}


void userInfoWindow::cb_openURLButtonClicked(userInfoWindow* self)
{
	uu_openURL(self->manager->info->website);
}
